#!/usr/bin/env python
'''
encrypt.py (c) 2013 Perry Harrington

This program will encrypt a Propeller 2 program payload using AES-128-CBC encryption with the given key.

This program is release under the MIT license.

'''

from Crypto.Cipher import AES
from Crypto import Random
from binascii import hexlify,unhexlify


def EncryptPayload(key, filename):
    
    binkey = unhexlify(key)

    with open(filename, "rb") as f:
        msg = f.read()
    iv = Random.new().read(AES.block_size)
    cipher = AES.new(binkey, AES.MODE_CBC, iv)
    return iv + cipher.encrypt(msg)
    
def main():
    from optparse import OptionParser
    
    usage = "usage: %prog [options] arg"
    parser = OptionParser(usage)
    parser.add_option("-f", "--file", dest="filename", help="calculate HMAC hash of FILE", metavar="FILE", default="payload")
    parser.add_option("-k", "--key", dest="key", help="hex string of key to sign with", metavar="KEY", default="15670d6f18a696c0368f6c01ee8236c0")
    
    (options, args) = parser.parse_args()
             
    print EncryptPayload(options.key,options.filename)

if __name__ == "__main__":
    main()